Index: trunk/kernel/kern/rpc.h
===================================================================
--- trunk/kernel/kern/rpc.h	(revision 690)
+++ trunk/kernel/kern/rpc.h	(revision 1)
@@ -2,5 +2,6 @@
  * rpc.h - RPC (Remote Procedure Call) operations definition.
  *
- * Author  Alain Greiner (2016,2017,2018,2019,2020)
+ * Authors Mohamed Karaoui (2015)
+ *         Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,9 +26,9 @@
 #define _RPC_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_atomic.h>
 #include <bits.h>
-#include <vseg.h>
+#include <spinlock.h>
 #include <remote_fifo.h>
 
@@ -35,18 +36,14 @@
 
 struct process_s;
-struct page_s;
 struct vseg_s;
 struct exec_info_s;
 struct pthread_attr_s;
 struct remote_sem_s;
-struct user_dir_s;
 struct fragment_s;
 struct vfs_inode_s;
 struct vfs_dentry_s;
-struct vfs_file_s;
 struct thread_s;
 struct mapper_s;
 
-
 /**********************************************************************************/
 /**************  structures for Remote Procedure Calls ****************************/
@@ -55,32 +52,32 @@
 /***********************************************************************************
  * This enum defines all RPC indexes.
- * It must be consistent with the rpc_server[] arrays defined in in the rpc.c file.
+ * It must be consistent with the rpc_server[] array defined in in the rpc.c file.
  **********************************************************************************/
 
 typedef enum
 {
-    RPC_UNDEFINED_0               = 0,   //
-    RPC_UNDEFINED_1               = 1,   //
-    RPC_UNDEFINED_2               = 2,   //      
-    RPC_PROCESS_MAKE_FORK         = 3,
-    RPC_USER_DIR_CREATE           = 4,
-    RPC_USER_DIR_DESTROY          = 5,
-    RPC_THREAD_USER_CREATE        = 6,
-    RPC_THREAD_KERNEL_CREATE      = 7,
-    RPC_UNDEFINED_8               = 8,
-    RPC_PROCESS_SIGACTION         = 9,
-
-    RPC_UNDEFINED_10              = 10,   //
-    RPC_UNDEFINED_11              = 11,   //
-    RPC_UNDEFINED_12              = 12,   // 
-    RPC_UNDEFINED_13              = 13,   //
-    RPC_UNDEFINED_14              = 14,   //
-    RPC_VMM_RESIZE_VSEG           = 15,
-    RPC_VMM_REMOVE_VSEG           = 16,
-    RPC_VMM_CREATE_VSEG           = 17,
-    RPC_VMM_SET_COW               = 18,
-    RPC_UNDEFINED_19              = 19,   //
-
-    RPC_MAX_INDEX                 = 20,
+    RPC_PMEM_GET_PAGES         = 0,
+    RPC_PROCESS_PID_ALLOC      = 1,
+    RPC_PROCESS_EXEC           = 2,
+    RPC_PROCESS_KILL           = 3,
+    RPC_THREAD_USER_CREATE     = 4,
+    RPC_THREAD_KERNEL_CREATE   = 5,
+	RPC_ICU_WTI_ALLOC          = 6,
+    RPC_DEVICE_ALLOC           = 7,
+
+    RPC_VFS_INODE_CREATE       = 10,
+    RPC_VFS_INODE_DESTROY      = 11,
+    RPC_VFS_DENTRY_CREATE      = 12,
+    RPC_VFS_DENTRY_DESTROY     = 13,
+
+    RPC_VMM_GET_REF_VSEG       = 20,
+    RPC_VMM_GET_PTE            = 21,
+    RPC_SEMAPHORE_ALLOC        = 22,
+    RPC_SEMAPHORE_FREE         = 23,
+    RPC_MAPPER_MOVE            = 24,
+
+    RPC_FATFS_GET_CLUSTER      = 30,
+
+    RPC_MAX_INDEX              = 31,
 }
 rpc_index_t;
@@ -94,18 +91,33 @@
 
 /***********************************************************************************
- *  This structure defines the RPC descriptor (100 bytes on a 32bits core)
+ *  This structure defines the RPC descriptor
  **********************************************************************************/
 
 typedef struct rpc_desc_s
 {
-	rpc_index_t         index;       /*! index of requested RPC service      ( 4) */
-	uint32_t          * rsp;         /*! local pointer ond responses counter ( 4) */
-    struct thread_s   * thread;      /*! local pointer on client thread      ( 4) */
-    uint32_t            lid;         /*! index of core running client thread ( 4) */ 
-    bool_t              blocking;    /*! simple RPC mode when true           ( 4) */
-    uint64_t            args[10];    /*! input/output arguments buffer       (80) */
+	rpc_index_t       index;       // index of requested RPC service
+	volatile uint32_t response;    // response valid when 0
+    uint64_t          args[8];     // input/output arguments buffer
 } 
 rpc_desc_t;
 
+/***********************************************************************************
+ * This structure defines the RPC fifo, containing a remote_fifo, the owner RPC
+ * thread TRDID (used as a light lock), and the intrumentation counter.
+ *
+ * Implementation note: the TRDID is a good owner identifier, because all
+ * RPC threads in a given cluster belong to the same process_zero kernel process,
+ * and RPC threads cannot have local index LTID = 0.
+ **********************************************************************************/
+
+typedef struct rpc_fifo_s
+{
+	trdid_t           owner;       // owner thread / 0 if no owner
+	uint64_t          count;       // total number of received RPCs (instrumentation) 
+	remote_fifo_t     fifo;        // embedded remote fifo
+} 
+rpc_fifo_t;
+
+
 /**********************************************************************************/
 /******* Generic functions supporting RPCs : client side **************************/
@@ -113,22 +125,16 @@
 
 /***********************************************************************************
- * This function is executed by the client thread in the client cluster. 
- * It puts one RPC descriptor defined by the <desc> argument in the remote fifo
- * defined by the <cxy> argument.  It sends an IPI to the server if fifo is empty.
- * The RPC descriptor must be allocated in the caller's stack, and initialised by
- * the caller. It exit with a Panic message if remote fifo is still full after 
- * (CONFIG_RPC_PUT_MAX_ITERATIONS) retries. 
- * - When the RPC <blocking> field is true, this function blocks and deschedule
- *   the client thread. It returns only when the server completes the RPC and
- *   unblocks the client thread.
- * - When the <blocking> field is false, this function returns as soon as the RPC
- *   has been registered in the FIFO, and the client thread must block itself when
- *   all RPCS have been registered in all target clusters.
+ * This blocking function executes on the client core. 
+ * It puts one RPC extended pointer in the remote fifo. 
+ * It sends an IPI if fifo is empty, and waits until RPC response available.
+ * The RPC descriptor must be allocated in the caller's stack
+ * and initialised by the caller.  Exit with a Panic message if remote fifo 
+ * is still full after (CONFIG_RPC_PUT_MAX_ITERATIONS) retries.
  ***********************************************************************************
  * @ cxy   : server cluster identifier
  * @ desc  : local pointer on RPC descriptor in client cluster
  **********************************************************************************/
-void rpc_send( cxy_t        cxy,    
-               rpc_desc_t * desc );
+void rpc_send_sync( cxy_t        cxy,    
+                    rpc_desc_t * desc );
 
 
@@ -139,23 +145,52 @@
 
 /***********************************************************************************
- * This function contains the infinite loop executed by a RPC server thread,
- * to handle pending RPCs registered in the RPC fifo attached to a given core.
- * In each iteration in this loop, it try to handle one RPC request:
- * - it tries to take the RPC FIFO ownership,
- * - it consumes one request when the FIFO is not empty,
- * - it releases the FIFO ownership,
- * - it execute the requested service,
- * - it unblock and send an IPI to the client thread,
- * - it suicides if the number of RPC threads for this core is to large,
- * - it block on IDLE and deschedule otherwise.  
- **********************************************************************************/
-void rpc_server_func( void );
+ * This function initialises the local RPC fifo and the lock protecting readers.
+ * The number of slots is defined by the CONFIG_REMOTE_FIFO_SLOTS parameter.
+ * Each slot contains an extended pointer on the RPC descriptor.
+ ***********************************************************************************
+ * @ rf     : pointer on the local RPC fifo.
+ **********************************************************************************/ 
+void rpc_fifo_init( rpc_fifo_t * rf );
+
+/***********************************************************************************
+ * This function is the entry point for RPC handling on the server side.
+ * It can be executed by any thread running (in kernel mode) on any core.
+ * It first checks the core private RPC fifo, an then the cluster shared RPC fifo.
+ * It calls the rpc_activate_thread() function to activate a dedicated RPC thread.
+ ***********************************************************************************
+ * @ returns true if at least one RPC found / false otherwise.
+ **********************************************************************************/
+bool_t rpc_check();
+
+/***********************************************************************************
+ * This function contains the loop to execute all pending RPCs on the server side.
+ * It should be called with irq disabled and after light lock acquisition.
+ ***********************************************************************************
+ * @ rpc_fifo  : pointer on the local RPC fifo
+ * @ returns 0 if success
+ **********************************************************************************/
+error_t rpc_execute_all( rpc_fifo_t * rpc_fifo );
+
+/**********************************************************************************
+ * This function is called by any thread running on any core in any cluster,
+ * that detected a non-empty RPC_FIFO and got the RPC_FIFO ownership.
+ * It activates one RPC thread, and immediately switches to the RPC thread.
+ * It gets the first free RPC thread from the core free-list, or creates a new one
+ * when the core free-list is empty. 
+ ***********************************************************************************
+ * @ rpc_fifo : pointer on the non-empty RPC fifo.
+ * @ return 0 if success / return ENOMEM if error.
+ **********************************************************************************/
+error_t rpc_activate_thread( rpc_fifo_t * rpc_fifo );
+
+/***********************************************************************************
+ * This function contains the infinite loop executed by each RPC thread.
+ **********************************************************************************/
+void rpc_thread_func();
 
 /***********************************************************************************
  * This function is executed in case of illegal RPC index.
  **********************************************************************************/
-void __attribute__((noinline)) rpc_undefined( xptr_t xp __attribute__ ((unused)) );
-
-
+void __attribute__((noinline)) rpc_undefined();
 
 /**********************************************************************************/
@@ -164,89 +199,73 @@
 
 /***********************************************************************************
- * [0] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [1] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [2] undefined
- **********************************************************************************/
-
-/***********************************************************************************
- * [3] The RPC_PROCESS_MAKE_FORK creates a "child" process descriptor, and the
- * associated "child" thread descriptor in a target remote cluster that can be 
- * any cluster.  The child process is initialized from informations found in the 
- * "parent" process descriptor (that must be the parent reference cluster),
- * and from the "parent" thread descriptor that can be in any cluster.
- ***********************************************************************************
- * @ cxy              : server cluster identifier.
- * @ ref_process_xp   : [in]  extended pointer on reference parent process.
- * @ parent_thread_xp : [in]  extended pointer on parent thread.
- * @ child_pid        : [out] child process identifier.
- * @ child_thread_ptr : [out] local pointer on child thread.
- * @ error            : [out]  error status (0 if success).
- **********************************************************************************/
-void rpc_process_make_fork_client( cxy_t              cxy,
-                                   xptr_t             ref_process_xp,
-                                   xptr_t             parent_thread_xp,
-                                   pid_t            * child_pid,
-                                   struct thread_s ** child_thread_ptr,
-                                   error_t          * error );
-
-void rpc_process_make_fork_server( xptr_t xp );
-
-/***********************************************************************************
- * [4] The RPC_USER_DIR_CREATE allows a client thread to create an user_dir_t
- * structure and the associated array of dirents in a remote cluster containing
- * the target directory <inode>. It creates an ANON vseg in the user reference 
- * process VMM identified by the <ref_xp>. This reference cluster cluster can be
- * different from both the client and server clusters.
- * It is called by the sys_opendir() function.
- ***********************************************************************************
- * @ cxy        : server cluster identifier.
- * @ inode      : [in]   local pointer on inode in server cluster.
- * @ ref_xp     : [in]   extended pointer on user reference process descriptor.
- * @ dir        : [out]  local pointer on created user_dir structure.
- **********************************************************************************/
-void rpc_user_dir_create_client( cxy_t                 cxy,
-                                 struct vfs_inode_s  * inode,
-                                 xptr_t                ref_xp,
-                                 struct user_dir_s  ** dir );
-
-void rpc_user_dir_create_server( xptr_t xp );
-
-/***********************************************************************************
- * [5] The RPC_USER_DIR_DESTROY allows a client thread to delete an user_dir_t
- * structure and the associated array of dirents in a remote cluster containing
- * the target directory inode. It is called by the sys_closedir() function.
- ***********************************************************************************
- * @ cxy        : server cluster identifier.
- * @ dir        : [in]  local pointer on created user_dir structure.
- * @ ref_xp     : [in]   extended pointer on user reference process descriptor.
- **********************************************************************************/
-void rpc_user_dir_destroy_client( cxy_t               cxy,
-                                  struct user_dir_s * dir,
-                                  xptr_t              ref_xp );
-
-void rpc_user_dir_destroy_server( xptr_t xp );
-
-/***********************************************************************************
- * [6] The RPC_THREAD_USER_CREATE creates an user thread in the server cluster,
- * as specified by the arguments. It returns an extended pointer on the new
- * thread descriptor in server cluster, and an error code.
- * It is called by the sys_thread_create() system call.
+ * The RPC_PMEM_GET_PAGES allocates one or several pages in a remote cluster,
+ * and returns the PPN of the first allocated page.
+ ***********************************************************************************
+ * @ cxy     : server cluster identifier
+ * @ order   : [in]  ln2( number of requested pages )
+ * @ error   : [out] error status (0 if success)
+ * @ ppn     : [out] first physical page number
+ **********************************************************************************/
+void rpc_pmem_get_pages_client( cxy_t      cxy,
+                                uint32_t   order,
+                                error_t  * error,
+                                uint32_t * ppn );
+
+void rpc_pmem_get_pages_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_PROCESS_PID_ALLOC allocates one new PID in a remote cluster, registers
+ * the new process in the remote cluster, and returns the PID, and an error code.
+ ***********************************************************************************
+ * @ cxy     : server cluster identifier.
+ * @ process : [in]  local pointer on process descriptor in client cluster.
+ * @ error   : [out] error status (0 if success).
+ * @ pid     : [out] new process identifier.
+ **********************************************************************************/
+void rpc_process_pid_alloc_client( cxy_t              cxy,
+                                   struct process_s * process,
+                                   error_t          * error,
+                                   pid_t            * pid );
+
+void rpc_process_pid_alloc_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_PROCESS_EXEC creates a process descriptor copy, in a remote cluster
+ * and initializes if from information found in the reference process descriptor.
+ * This remote cluster becomes the new reference cluster.
+ ***********************************************************************************
+ * @ cxy     : server cluster identifier.
+ * @ info    : [in]   pointer on local exec_info structure.
+ * @ error   : [out]  error status (0 if success).
+ **********************************************************************************/
+void rpc_process_exec_client( cxy_t                cxy,
+                              struct exec_info_s * info,
+                              error_t            * error );
+
+void rpc_process_exec_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_PROCESS_KILL is actually a multicast RPC sent by the reference cluster
+ * to other clusters containing a process descriptor copy, to destroy these copies.
+ ***********************************************************************************
+ * @ process  : local pointer on target process.
+ **********************************************************************************/
+void rpc_process_kill_client( struct process_s * process );
+
+void rpc_process_kill_server( xptr_t xp );
+
+/***********************************************************************************
+ * The RPC_THREAD_USER_CREATE creates an user thread in the server cluster,
+ * as specified by the pthread_attr_t argument. It returns the local pointer
+ * on the thread descriptor in server cluster, and an error code.
+ * It is called by the pthread_create system call.
  ***********************************************************************************
  * @ cxy       : server cluster identifier.
- * @ attr      : [in]  local pointer on pthread_attr_t in client cluster.
- * @ thread_xp : [out] buffer for thread extended pointer. 
+ * @ attr      : [in]  pointer on pthread_attr_t in client cluster.
+ * @ thread_xp : [out] pointer on buffer for thread extended pointer. 
  * @ error     : [out] error status (0 if success).
  **********************************************************************************/
 void rpc_thread_user_create_client( cxy_t                   cxy,
-                                    pid_t                   pid,
-                                    void                  * start_func,
-                                    void                  * start_arg,
-                                    pthread_attr_t        * attr,
+                                    struct pthread_attr_s * attr,
                                     xptr_t                * thread_xp,
                                     error_t               * error );
@@ -255,8 +274,8 @@
 
 /***********************************************************************************
- * [7] The RPC_THREAD_KERNEL_CREATE creates a kernel thread in the server cluster,
+ * The RPC_THREAD_KERNEL_CREATE creates a kernel thread in the server cluster,
  * as specified by the type, func and args arguments. It returns the local pointer
  * on the thread descriptor in server cluster and an error code.
- * It is used by the dev_init() function to create the device server thread.
+ * It is used by the dev_init() function to cretae the device server thread.
  ***********************************************************************************
  * @ cxy       : server cluster identifier.
